'
' Copyright 2003 Captator - de danske .NET eksperter
'
' Denne kode er til fri afbenyttelse.
' Koden er lavet som et eksempel i forbindelse med artiklen "Versionering .NET frameworket".
' Har du ikke artiklen, kan du finde den p www.captator.dk
' Finder du en fejl s lad vre med at sagsge os ;^)
' Fortl os i stedet for om  fejl og forslag til forbedringer p f.eks. e-mail: lykke@captator.dk 

'
' Dette er et generelt versionschecker utility. Du kan inkluder denne klasse i din applikation, og anvende
' den til at checke om de versioner dit program er compileret til (referenced assemblies) ogs er dem
' der er loaded nr programmet er startet op. 
'
' Alt efter situationen kan informationer om, at der ikke er match mellem referenced og loaded assembly
' benyttes til at ngte at starte programmet eller informationen kunne logges, s man ved en fejl har mulighed
' for at se om fejlen skyldes at der benyttes andre versioner end de forventede.


Namespace Captator.Eifos.Versioning

  Public Class AssemblyVersionInfo
    Public ReferencedAssemblyName As System.Reflection.AssemblyName
    Public LoadedAssemblyName As System.Reflection.AssemblyName
  End Class

  Public Class VersionCheckerUtil

    Public Shared Function GetAssemblyReferences(ByVal ass As System.Reflection.Assembly, ByVal recursive As Boolean) As System.Collections.ArrayList

      Dim assNames As New System.Collections.ArrayList

      GetAssemblyReferences(assNames, ass, recursive)

      Return assNames

    End Function

    Public Shared Sub GetAssemblyReferences(ByVal assNames As System.Collections.ArrayList, ByVal ass As System.Reflection.Assembly, ByVal recursive As Boolean)

      Dim assName As System.Reflection.AssemblyName
      Dim ReferencedAss As System.Reflection.Assembly
      Dim tempAssNames As System.Collections.ArrayList

      For Each assName In ass.GetReferencedAssemblies()

        If Not Contains(assNames, assName) Then
          assNames.Add(assName)
          ReferencedAss = System.Reflection.Assembly.Load(assName)
          If recursive Then
            GetAssemblyReferences(assNames, ReferencedAss, recursive)
          End If
        End If

      Next

    End Sub

    Public Shared Function GetActualAssemblyReferences(ByVal ass As System.Reflection.Assembly, ByVal recursive As Boolean) As System.Collections.ArrayList

      Dim assNames As New System.Collections.ArrayList

      GetActualAssemblyReferences(assNames, ass, recursive)

      Return assNames

    End Function

    Public Shared Sub GetActualAssemblyReferences(ByVal assNames As System.Collections.ArrayList, ByVal ass As System.Reflection.Assembly, ByVal recursive As Boolean)

      Dim assName As System.Reflection.AssemblyName
      Dim ReferencedAss As System.Reflection.Assembly
      Dim tempAssNames As System.Collections.ArrayList

      For Each assName In ass.GetReferencedAssemblies()

        If Not Contains(assNames, assName) Then
          If recursive Then
            ReferencedAss = System.Reflection.Assembly.Load(assName)
            assNames.Add(ReferencedAss.GetName())
            GetActualAssemblyReferences(assNames, ReferencedAss, recursive)
          End If
        End If

      Next

    End Sub

    Public Shared Function GetReferenceDiffs(ByVal ass As System.Reflection.Assembly, ByVal recursive As Boolean) As System.Collections.ArrayList

      Dim assNamesReferenced As System.Collections.ArrayList
      Dim assnamesDiff As System.Collections.ArrayList

      assNamesReferenced = GetAssemblyReferences(ass, recursive)

      assnamesDiff = GetReferenceDiffs(assNamesReferenced)

      Return assnamesDiff

    End Function

    Public Shared Function GetReferenceDiffs(ByVal assNamesReferenced As System.Collections.ArrayList) As System.Collections.ArrayList

      Dim assNamesDiff As New System.Collections.ArrayList
      Dim assname As System.Reflection.AssemblyName
      Dim LoadedAssembly As System.Reflection.Assembly
      Dim assInfo As AssemblyVersionInfo

      For Each assname In assNamesReferenced
        assInfo = New AssemblyVersionInfo
        LoadedAssembly = System.Reflection.Assembly.Load(assname)
        If Not IsIdentical(LoadedAssembly.GetName(), assname) Then
          assInfo.ReferencedAssemblyName = assname
          assInfo.LoadedAssemblyName = LoadedAssembly.GetName()
          assNamesDiff.Add(assInfo)
        End If
      Next

      Return assNamesDiff

    End Function

    Private Shared Function IsIdentical(ByVal assName1 As System.Reflection.AssemblyName, ByVal assName2 As System.Reflection.AssemblyName) As Boolean

      If assName1.FullName = assName2.FullName Then
        Return True
      Else
        Return False
      End If

    End Function

    Private Shared Function Contains(ByVal list As System.Collections.ArrayList, ByVal assName As System.Reflection.AssemblyName) As Boolean

      Dim obj As Object

      For Each obj In list
        If IsIdentical(CType(obj, System.Reflection.AssemblyName), assName) Then
          Return True
        End If
      Next

      Return False

    End Function

  End Class

End Namespace